// Copyright 2013 Atbrox AS
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#import "EliasGammaDecoder.h"

@implementation EliasGammaDecoder

@synthesize decodedDataLength = _decodedDataLength;

- (CFMutableArrayRef)decode:(NSData *)data {
    
    CFMutableArrayRef numbers = CFArrayCreateMutable(kCFAllocatorDefault, 0, NULL);
    NSUInteger i = 0;
    BOOL *bytes = (BOOL *)data.bytes;
    while (i < data.length) {
        // Find bit length by reading unary
        
        // (bits[bit >> 3] & (1 << (bit & 7)))
        
        NSUInteger length = 0;
        NSUInteger number = 0;
        for (NSUInteger j = i; ; j++) {
            length++;
            if (j >= data.length) {
                break;
            }
            BOOL bit = bytes[j];
            if (bit) {
                break;
            }
        }
        
//        NSLog(@"Decoding from i = %i", i);
        
        if (i + (length << 1) - 1 > data.length) {
//            NSLog(@"Limit: %i", i + (length << 1) - 1);
//            NSLog(@"Breaking decode at position %i. Decode data is not complete.", i);
            _decodedDataLength = i;
            break;
        }
        
        NSUInteger bitPosition = i + length - 1;
        for (NSInteger k = length - 1; k >= 0; k--) {
            BOOL bit = bytes[bitPosition];
            if (bit) {
                number |= 1 << k;
            }
            bitPosition++;
        }
        i = bitPosition;
        _decodedDataLength = i;
        CFArrayAppendValue(numbers, (void *)number);
    }
    
    return numbers;
}

- (NSString *)scheme {
    return @"Elias Gamma";
}

@end
