// Copyright 2013 Atbrox AS
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#import "NSMutableDictionary+EncodedPostingList.h"


@implementation NSMutableDictionary (EncodedPostingList)

-(NSData *) entriesAsNSData;
{
    NSMutableData *totalData = [NSMutableData dataWithCapacity:[self totalByteSize]];
    for (id key in self)
    {
        NSData *data = (NSData *)[self objectForKey:key];
        [totalData appendData:data];
    }
    return totalData;
}

-(NSUInteger) totalByteSize
{
    NSUInteger totalByteSize = 0;
    for (id key in self)
    {
        NSData *data = (NSData *)[self objectForKey:key];
        totalByteSize += data.length;
    }
    return totalByteSize;
}



@end
