// Copyright 2013 Atbrox AS
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#import <Foundation/Foundation.h>

#import "PostingListModel.h"
#import "RawPostingListReader.h"
#import "NSMutableDictionary+EncodedPostingList.h"
#import "NSMutableArray+Queue.h"
#import "PostingListEncoder.h"
#import "BundledRead.h"
#import "CompressionToolbox.h"

typedef struct ThreadEntryCount {
    NSUInteger start;
    NSUInteger end;
} ThreadEntryCount;

@interface ParallelEncodingModel : PostingListModel

@property PostingListEncoder *encoder;

-(NSDictionary *) encodedUrlsForTerm:(NSString *)term;

-(BOOL) _preprocess:(PostingListEntry *)preProcessObject;
-(BOOL) _process:(PostingListEntry *)processObject;
-(BOOL) _postprocess:(PostingListEntry *)postProcessObject;


@end
