// Copyright 2013 Atbrox AS
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#import <Foundation/Foundation.h>

@interface PostingListEntry : NSObject

@property NSString *term;
@property NSRange range;
@property NSUInteger lastReadPosition;      // Last file position that was read.
@property NSUInteger lastReadValue;         // Last value that was tried encoded.
@property NSData *encodedDataTail;          // Last set of encoded data.
@property NSData *bufferTail;       // The last few bytes of the previous buffer.
@property NSData *buffer;                   // Current buffer of read bytes.
@property CFMutableArrayRef toEncodeBuffer;            // Current buffer of unencoded values.
@property CFMutableArrayRef toEncodeBufferTail;
@property CFMutableArrayRef haveDecodedBuffer;
@property NSData *data;
@property NSUInteger dataLength;
@property NSUInteger numberOfEntries;

@end
