// Copyright 2013 Atbrox AS
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#import <Foundation/Foundation.h>

@interface RawPostingListReader : NSObject

@property NSString *path;
@property NSUInteger blockSize;
@property (readonly) NSUInteger position;
@property (readonly) NSUInteger length;

-(id) initFromPath:(NSString *)path withBlockSize:(NSUInteger)blockSize;
-(id) initFromFileHandle:(NSFileHandle *)fileHandle withBlockSize:(NSUInteger)blockSize;

-(void) loadFromPath:(NSString *)path;
-(void) closeFile;
-(NSData *) readData;
-(NSData *) readData:(NSUInteger)length;
-(NSData *) getPostingList:(NSRange)byteRange blockWiseRead:(BOOL)blockWise;

@end
