// Copyright 2013 Atbrox AS
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#import "VariableByteDecoder.h"

@implementation VariableByteDecoder

@synthesize decodedDataLength = _decodedDataLength;

- (CFMutableArrayRef)decode:(NSData *)data {
    
    CFMutableArrayRef numbers = CFArrayCreateMutable(kCFAllocatorDefault, 0, NULL);
    NSUInteger number = 0;

    const Byte *bytes = data.bytes;
    for (int i = 0; i < data.length; i++)
    {
        Byte value = (Byte)bytes[i];
        if (value < 128)
            number = (number << 7) + value;
        else
        {
            NSUInteger decodedNumber = (number << 7) + (value - 128);
            CFArrayAppendValue(numbers, (void *)decodedNumber);
            //                NSLog(@"Number %li decoded.", number);
            _decodedDataLength = i;
            number = 0;
        }
        //            NSLog(@"Resulting number: %li", number);
    }
    
//    NSLog(@"Finished encoding block");
    
    return numbers;
}

- (NSString *)scheme {
    return @"Variable Byte";
}


@end
