//
//  VariableByteTests.m
//  PostingListCompression
//
//  Created by Lars Martin S. Pedersen on 10/7/13.
//  Copyright (c) 2013 Atbrox AS. All rights reserved.
//

#import <XCTest/XCTest.h>
#import <Foundation/Foundation.h>

#import "Encoder.h"
#import "Decoder.h"

@interface VariableByteTests : XCTestCase
{
    Encoder *encoder;
    Decoder *decoder;
}

@end

@implementation VariableByteTests

- (void)setUp
{
    [super setUp];
    encoder = [[Encoder alloc] init];
    decoder = [[Decoder alloc] init];
    // Put setup code here; it will be run once, before the first test case.
}

- (void)tearDown
{
    // Put teardown code here; it will be run once, after the last test case.
    [super tearDown];
}

- (void)testEncodeNumber
{
    NSData *anEncodedNumber = [encoder encodeNumber:[NSNumber numberWithInteger:1]];
    NSData *secondEncodedNumber = [encoder encodeNumber:[NSNumber numberWithInteger:1024]];
    XCTAssertTrue(anEncodedNumber.length == 1);
    XCTAssertTrue(secondEncodedNumber.length == 2);
}

- (void)testEncodeAndDecode
{
    NSArray *numbers = @[[NSNumber numberWithInteger:1], [NSNumber numberWithInteger:4], [NSNumber numberWithInteger:1377]];
    encoder.numbers = numbers;
    NSData *encodedNumbers = [encoder encode];
    XCTAssertTrue(encodedNumbers.length == 4);
    
    NSFileHandle *handle = [NSFileHandle fileHandleForReadingAtPath:@"/Users/lars/Workspace/memkite-backend/var/memkite/2013-10-07T100047_ii-encode_all.txt"];
    if (handle)
    {
        NSLog(@"Found file.");
        [handle seekToFileOffset:12276636];
        NSData *data = [handle readDataOfLength:600];
        decoder.encodedNumbers = data;
        NSLog(@"Decoded: %@", [decoder decode]);
    }
    
    decoder.encodedNumbers = encodedNumbers;
    NSArray *decodedNumbers = [decoder decode];
    for (NSUInteger i = 0; i < decodedNumbers.count; i++)
        XCTAssertEqualObjects(numbers[i], decodedNumbers[i]);
}

@end
