//
//  NSMutableArray+Statistics.m
//  PostingListCompression
//
//  Created by Lars Martin S. Pedersen on 9/23/13.
//  Copyright (c) 2013 Atbrox AS. All rights reserved.
//

#import "NSMutableArray+Statistics.h"

#import "Stat.h"

@implementation NSMutableArray (Statistics)

-(float) sum
{
    float sum = 0.0;
    for (Stat *s in self)
        sum += [s duration];
    return sum;
}

-(float) average
{
    return [self sum] / self.count;
}

-(float) max
{
    float max = 0.0;
    if (self.count > 0)
    {
        for (Stat *s in self)
        {
            if ([s duration] > max)
                max = [s duration];
        }
    }
    return max;
}

-(float) min
{
    float min = 0.0;
    if (self.count > 0)
    {
        for (Stat *s in self)
        {
            if ([s duration] < min)
                min = [s duration];
        }
    }
    return min;
}

@end
