// Copyright 2013 Atbrox AS
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#import <Foundation/Foundation.h>

@interface FileReader : NSObject

@property NSUInteger blockSize;
@property NSString *input;
@property NSUInteger iterations;
@property (readonly) NSMutableString *log;
@property (readonly) float totalDuration;
@property (readonly) float averageDuration;
@property (readonly) float averageTransferRate;
@property (readonly) NSUInteger totalBytes;
@property (readonly) NSUInteger currentReadBytes;
@property (readonly) NSUInteger currentIteration;
@property (readonly) NSUInteger numberOfBlocks;
@property (readonly) NSDate *start;
@property (readonly) NSDate *end;

-(id) init;
-(id) initFromPath:(NSString *)path;

-(NSUInteger) totalBytes;
-(NSUInteger) currentReadBytes;

-(void) resetCounters;
-(void) read:(BOOL)random;
-(void) writeLog:(NSString *)path;

@end
