// Copyright 2013 Atbrox AS
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#import <UIKit/UIKit.h>

@interface ViewController : UIViewController <UITextFieldDelegate>
{
    UITapGestureRecognizer *gestureRecognizer;
    
    UIButton *startButton;
    
    UILabel *iterationsLabel;
    UITextField *iterationsText;
    
    UILabel *statusLabel;
    UIProgressView *iterationProgress;
    UIProgressView *totalProgress;
    UILabel *totalProgressLabel;
    
    UILabel *blockLabel;
    UITextField *blockText;
    
    UILabel *randomLabel;
    UISwitch *randomToggle;
    
    UIButton *saveButton;
}

@property (nonatomic, retain) IBOutlet UITapGestureRecognizer *gestureRecognizer;

@property (nonatomic, retain) IBOutlet UIButton *startButton;

@property (nonatomic, retain) IBOutlet UILabel *iterationsLabel;
@property (nonatomic, retain) IBOutlet UITextField *iterationsText;

@property (nonatomic, retain) IBOutlet UILabel *statusLabel;
@property (nonatomic, retain) IBOutlet UIProgressView *iterationProgress;
@property (nonatomic, retain) IBOutlet UIProgressView *totalProgress;
@property (nonatomic, retain) IBOutlet UILabel *totalProgressLabel;

@property (nonatomic, retain) IBOutlet UILabel *blockLabel;
@property (nonatomic, retain) IBOutlet UITextField *blockText;

@property (nonatomic, retain) IBOutlet UILabel *randomLabel;
@property (nonatomic, retain) IBOutlet UISwitch *randomToggle;

@property (nonatomic, retain) IBOutlet UIButton *saveButton;

-(IBAction) start:(id)sender;
-(IBAction) dismissKeyboard:(id)sender;
-(IBAction) saveLog:(id)sender;
-(IBAction) toggleRandom:(id)sender;

-(void) updateProgressUI;


@end
